local VERSION = tonumber(("$Revision: 31414 $"):match("%d+"))

local PitBull = PitBull
local PitBull_Name = PitBull:NewModule("Name")
local self = PitBull_Name
if PitBull.revision < VERSION then
	PitBull.version = "r" .. VERSION
	PitBull.revision = VERSION
	PitBull.date = ("$Date: 2007-03-30 15:15:20 -0400 (Fri, 30 Mar 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end

local new, del, newHash = PitBull.new, PitBull.del, PitBull.newHash
local newFrame, delFrame = PitBull.newFrame, PitBull.delFrame
local wrap = PitBull.wrap

PitBull_Name:RegisterPitBullChildFrames('nameText')

function PitBull_Name:OnPopulateUnitFrame(unit, frame)
	local nameText = newFrame("FontString", frame.overlay, "OVERLAY")
	frame.nameText = nameText
	nameText:SetFontObject(GameFontHighlightSmall)
	nameText:SetNonSpaceWrap(false)
	PitBull:RegisterWatchdogFontString(nameText, unit, "[name]")
end

function PitBull_Name:OnClearUnitFrame(unit, frame)
	frame.nameText = delFrame(frame.nameText)
end

function PitBull_Name:OnUnknownLayout(unit, frame, name)
	if frame.healthBar then
		frame.nameText:SetPoint("LEFT", frame.healthBar, "LEFT", 3, 0)
		if frame.healthText then
			frame.nameText:SetPoint("RIGHT", frame.healthText, "LEFT", -5, 0)
		end
	end
end

wrap(PitBull_Name, 'Name')
