local VERSION = tonumber(("$Revision: 31235 $"):match("%d+"))

local PitBull = PitBull
local PitBull_PvP = PitBull:NewModule("PvP", "AceEvent-2.0")
local self = PitBull_PvP
if PitBull.revision < VERSION then
	PitBull.version = "r" .. VERSION
	PitBull.revision = VERSION
	PitBull.date = ("$Date: 2007-03-28 21:23:22 -0400 (Wed, 28 Mar 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end

local new, del, newHash = PitBull.new, PitBull.del, PitBull.newHash
local newFrame, delFrame = PitBull.newFrame, PitBull.delFrame
local wrap = PitBull.wrap

PitBull_PvP:RegisterPitBullChildFrames('pvpIcon')

function PitBull_PvP:OnEnable()
	self:RegisterEvent("UPDATE_FACTION", "Update")
	self:RegisterEvent("PLAYER_FLAGS_CHANGED", "Update")
	self:RegisterEvent("UNIT_FACTION", "Update")
end

function PitBull_PvP:Update(unit, noPet)
	if not unit then
		unit = "player"
	end
	
	local frame = PitBull:GetUnitFrame(unit)
	if frame then
		local has = false
		
		if UnitIsPVPFreeForAll(unit) then
			has = 'FFA'
		else
			local faction = UnitFactionGroup(unit)
			if faction and UnitIsPVP(unit) then
				has = faction
			end
		end
		
		if has then
			if not frame.pvpIcon then
				frame.pvpIcon = newFrame("Texture", frame.overlay, "ARTWORK")
				
				PitBull:UpdateLayout(unit)
			end
			frame.pvpIcon:SetTexture("Interface\\TargetingFrame\\UI-PVP-" .. has)
		else
			if frame.pvpIcon then
				frame.pvpIcon = delFrame(frame.pvpIcon)

				PitBull:UpdateLayout(unit)
			end
		end
	end
	
	if not noPet then
		if unit == "player" then
			self:Update("pet")
		else
			local num = unit:match("^party(%d)$")
			if num then
				self:Update("partypet" .. num)
			end
		end
	end
end

function PitBull_PvP:OnUpdateFrame(unit, frame)
	self:Update(unit, true)
end

function PitBull_PvP:OnClearUnitFrame(unit, frame)
	if frame.pvpIcon then
		frame.pvpIcon = delFrame(frame.pvpIcon)
	end
end

function PitBull_PvP:OnUnknownLayout(unit, frame)
	frame.pvpIcon:SetPoint("TOPRIGHT", frame, "TOPRIGHT", 14, 2)
	frame.pvpIcon:SetWidth(27)
	frame.pvpIcon:SetHeight(27)
end

wrap(PitBull_PvP, 'PvP')
